﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridColumnClickDemo
{
    public partial class Form1 : Form
    {
        Random r = new Random();
        public Form1()
        {
            InitializeComponent();

            DataTable table = new DataTable();
            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Label", typeof(string));
            table.Columns.Add("Number", typeof(int));

            for(int i=0; i < 10; i++)
            {
                DataRow row = table.NewRow();
                row[0] = i;
                row[1] = "Item " + i.ToString();
                row[2] = r.Next(1000);
                table.Rows.Add(row);
            }


            ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            ultraGrid1.DataSource = table;
            ultraGrid1.MouseDown += UltraGrid1_MouseDown;                        
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortSingle;
        }

        private void UltraGrid1_MouseDown(object sender, MouseEventArgs e)
        {
            UltraGrid grid = (UltraGrid)sender;
            UIElement element = grid.DisplayLayout.UIElement.LastElementEntered;
            Infragistics.Win.UltraWinGrid.ColumnHeader columnHeader = element.GetContext(typeof(Infragistics.Win.UltraWinGrid.ColumnHeader)) as Infragistics.Win.UltraWinGrid.ColumnHeader;

            if (columnHeader == null)
                return;

            if ((Control.ModifierKeys & Keys.Alt) == Keys.Alt)
            {
                columnHeader.Column.SortIndicator = SortIndicator.Disabled;
                grid.DisplayLayout.Override.HeaderClickAction = HeaderClickAction.Select;
                ultraGrid1.Selected.Columns.Add(columnHeader);                
            }
            else
            {
                if (columnHeader.Column.SortIndicator == SortIndicator.Disabled)
                    columnHeader.Column.SortIndicator = SortIndicator.Ascending;

                if (grid.Selected.Columns.Count != 0)
                {
                    grid.Selected.Columns.Clear();
                }
                grid.DisplayLayout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
            }
        }
    }
}
